﻿define([], function () {
  "use strict";
  return {
    _goToCampaignActivity: ["37C3B57C8B4C4DA7B2EDEB5D5F9A6CE8"],
    _goToExperienceAnalytics: ["44D0308F773A461287766AD627A65734"],
    _deleteCampaign: ["386AA0C4E50440CCB6781CBCAF3FB3E0"],
    _exportCampaigns: ["AEBF3BB601C34EA280D34658D8B5060A"],

    addBaseStructure: function (baseStructure) {
      baseStructure.control.on("change:selectedItem", function () {
        this.setAvailableActions(baseStructure);
      }, this);
      baseStructure.dataSource.on("change:items", function () {
        baseStructure.control.set("selectedItem", "");
        baseStructure.control.set("selectedItemId", "");
        this.setAvailableActions(baseStructure);
      }, this);
      this.setAvailableActions(baseStructure);
    },

    setAvailableActions: function (baseStructure) {
      var alwaysAvaliableActions = [];
      var availableActions;
      var selectedItem = baseStructure.control.get("selectedItem");
      var items = baseStructure.dataSource.get("items");

      if (items && items.length > 0) {
        alwaysAvaliableActions = this._exportCampaigns;
      }

      if (typeof selectedItem === "undefined" || selectedItem === null || selectedItem === "") {
        availableActions = alwaysAvaliableActions;
      } else {
        availableActions = alwaysAvaliableActions.concat(this._goToCampaignActivity, this._goToExperienceAnalytics, this._deleteCampaign);
      }

      Array.prototype.forEach.call(baseStructure.actionControl.viewModel.actions(), function (el) {
        if (availableActions.indexOf(el.id()) < 0) {
          el.disable();
        } else {
          el.enable();
        }
      });
    }
  };
});